/*******************************************************************************
 * Generic VGA fixed clocks
 *******************************************************************************
 *
   Copyright (c) 1995 by Steffen Seeger
 *
   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 *******************************************************************************
 * 
 * $Log: vga.c,v $
 * Revision 1.5  1998/12/03 22:56:19  becka
 * Fixed a few uglinesses, that clash with suidkgi.
 *
 * Revision 1.4  1998/11/19 02:43:04  marcus
 * License change
 *
 * Revision 1.3  1998/10/25 18:07:34  marcus
 * More namespace cleanups
 *
 * Revision 1.2  1998/10/04 03:17:07  brian
 * Added private data hook to KGI_COMMON -- clean and recompile kgicon!
 *
 * Revision 1.1  1998/07/07 08:01:52  taylorj
 * *** empty log message ***
 *
 * Revision 1.6  1997/11/08 15:12:42  becka
 * Namespace cleanup ... probably broke all and everything ...
 *
 * Revision 1.5  1997/10/03 12:37:14  seeger
 * Added standard driver defines.
 *
 * Revision 1.4  1997/09/12 07:28:44  taylorj
 * Minor: Reformatted source to be consistent with GGI coding style guidelines,
 * modified all debugging output to use the DEBUGx macros, and added CVS
 * revision logging to headers where needed.
 *
 * 
 *******************************************************************************
 * 
 */

#include <kgi/maintainers.h>
#define	MAINTAINER	Steffen_Seeger
#define	DRIVER_NAME	"VGA clock driver"
#define	DRIVER_REV	"$Revision: 1.5 $"


#include <kgi/module.h>

struct kgi_clock kgi_fixed_clock =
{
	"Generic",		/* Manufacturer		*/
	"VGA",			/* Model		*/
	GM_ALL,			/* Supported modes	*/
	0,			/* Special capabilities	*/
	{ 0x7FFF, 0x7FFF },	/* Maximum resolution	*/
	NULL,			/* Private data hook	*/
	CLK_TYPE_FIXED,		/* Fixed clock values	*/

	/*	The clock values. Note that they have to be in descending
	**	order and that there must be no repetitions.
	*/
	{{  28322000,  25175000,         0,         0,
	           0,         0,         0,         0,
	           0,         0,         0,         0,
	           0,         0,         0,         0
	}}
};

/* Driving CS[0:3] to clkindex[i] selects kgi_fixed_clock.clock.freq[i] */
static kgiu8 clkindex[MAX_FIXED_CLOCKS] =
{	
	0x01, 0x00, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF
};

static inline struct kgi_clock *init_clock(void)
{
	/* No detection, the chipset driver does it */
	return &kgi_fixed_clock;
}

static inline void done_clock(void)
{
}

#include "fixed.inc"
